# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
# implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from django.conf.urls import patterns  # noqa
from django.conf.urls import url  # noqa

from horizon_bsn.content.connections.reachability_tests \
    import views

VIEWS_MOD = (
    'horizon_bsn.content.connections.reachability_tests.views')

urlpatterns = patterns(
    VIEWS_MOD,
    url(r'^create/$', views.CreateView.as_view(), name='create'),
    url(r'^run/$', views.RunQuickTestView.as_view(), name='run'),
    url(r'^quicktest/$', views.QuickDetailView.as_view(), name='quick'),
    url(r'^save/$', views.SaveQuickTestView.as_view(), name='save'),
    url(r'^(?P<id>[^/]+)/update/$',
        views.UpdateView.as_view(), name='update'),
    url(r'^(?P<id>[^/]+)/$',
        views.DetailView.as_view(), name='detail'),
)
